Index: branches/HeuristicLab.Problems.GrammaticalOptimization/Test/RunBaselineExperiments.cs
===================================================================
--- branches/HeuristicLab.Problems.GrammaticalOptimization/Test/RunBaselineExperiments.cs	(revision 11981)
+++ branches/HeuristicLab.Problems.GrammaticalOptimization/Test/RunBaselineExperiments.cs	(revision 11981)
@@ -0,0 +1,312 @@
+﻿using System;
+using System.Collections;
+using System.Collections.Generic;
+using HeuristicLab.Algorithms.Bandits.BanditPolicies;
+using HeuristicLab.Algorithms.Bandits.GrammarPolicies;
+using HeuristicLab.Algorithms.GeneticProgramming;
+using HeuristicLab.Algorithms.GrammaticalOptimization;
+using HeuristicLab.Problems.GrammaticalOptimization;
+using HeuristicLab.Problems.GrammaticalOptimization.SymbReg;
+using Microsoft.VisualStudio.TestTools.UnitTesting;
+using RandomPolicy = HeuristicLab.Algorithms.Bandits.BanditPolicies.RandomPolicy;
+
+namespace HeuristicLab.Problems.GrammaticalOptimization.Test {
+
+
+  [TestClass]
+  public class RunBaselineExperiments {
+    private readonly static int randSeed = 31415;
+
+    internal class Configuration {
+      public ISymbolicExpressionTreeProblem Problem;
+      public int MaxSize;
+      public int RandSeed;
+
+      public override string ToString() {
+        return string.Format("{0} {1} {2}", RandSeed, Problem, MaxSize);
+      }
+    }
+
+    #region permutation
+    [TestMethod]
+    public void RunPureRandomSearchPermutationProblem() {
+      var instanceFactories = new Func<int, ISymbolicExpressionTreeProblem>[]
+      {
+        (randSeed) => (ISymbolicExpressionTreeProblem)new PermutationProblem(), 
+      };
+
+      var maxSizes = new int[] { 32 };
+      int nReps = 20;
+      int maxIterations = 50000;
+      foreach (var instanceFactory in instanceFactories) {
+        foreach (var conf in GenerateConfigurations(instanceFactory, nReps, maxSizes)) {
+          RunPureRandomSearchForProblem(conf.RandSeed, conf.Problem, maxIterations, conf.MaxSize);
+        }
+      }
+    }
+    [TestMethod]
+    public void RunRandomSearchNoResamplingPermutationProblem() {
+      var instanceFactories = new Func<int, ISymbolicExpressionTreeProblem>[]
+      {
+        (randSeed) => (ISymbolicExpressionTreeProblem)new PermutationProblem(), 
+      };
+
+      var maxSizes = new int[] { 32 };
+      int nReps = 20;
+      int maxIterations = 50000;
+      foreach (var instanceFactory in instanceFactories) {
+        foreach (var conf in GenerateConfigurations(instanceFactory, nReps, maxSizes)) {
+          RunRandomSearchNoResamplingForProblem(conf.RandSeed, conf.Problem, maxIterations, conf.MaxSize);
+        }
+      }
+    }
+    #endregion
+
+    #region royalpair
+    [TestMethod]
+    public void RunPureRandomSearchRoyalPairProblem() {
+      var instanceFactories = new Func<int, ISymbolicExpressionTreeProblem>[]
+      {
+        (randSeed) => (ISymbolicExpressionTreeProblem)new RoyalPairProblem(), 
+      };
+
+      var maxSizes = new int[] { 32, 64, 128, 256 };
+      int nReps = 20;
+      int maxIterations = 50000;
+      foreach (var instanceFactory in instanceFactories) {
+        foreach (var conf in GenerateConfigurations(instanceFactory, nReps, maxSizes)) {
+          RunPureRandomSearchForProblem(conf.RandSeed, conf.Problem, maxIterations, conf.MaxSize);
+        }
+      }
+    }
+    [TestMethod]
+    public void RunRandomSearchNoResamplingRoyalPairProblem() {
+      var instanceFactories = new Func<int, ISymbolicExpressionTreeProblem>[]
+      {
+        (randSeed) => (ISymbolicExpressionTreeProblem)new RoyalPairProblem(), 
+      };
+
+      var maxSizes = new int[] { 32, 64, 128, 256 };
+      int nReps = 20;
+      int maxIterations = 50000;
+      foreach (var instanceFactory in instanceFactories) {
+        foreach (var conf in GenerateConfigurations(instanceFactory, nReps, maxSizes)) {
+          RunRandomSearchNoResamplingForProblem(conf.RandSeed, conf.Problem, maxIterations, conf.MaxSize);
+        }
+      }
+    }
+    #endregion
+
+    #region royalsymbol
+    [TestMethod]
+    public void RunPureRandomSearchRoyalSymbolProblem() {
+      var instanceFactories = new Func<int, ISymbolicExpressionTreeProblem>[]
+      {
+        (randSeed) => (ISymbolicExpressionTreeProblem)new RoyalSymbolProblem(), 
+      };
+
+      var maxSizes = new int[] { 32, 64, 128, 256 };
+      int nReps = 20;
+      int maxIterations = 50000;
+      foreach (var instanceFactory in instanceFactories) {
+        foreach (var conf in GenerateConfigurations(instanceFactory, nReps, maxSizes)) {
+          RunPureRandomSearchForProblem(conf.RandSeed, conf.Problem, maxIterations, conf.MaxSize);
+        }
+      }
+    }
+    [TestMethod]
+    public void RunRandomSearchNoResamplingRoyalSymbolProblem() {
+      var instanceFactories = new Func<int, ISymbolicExpressionTreeProblem>[]
+      {
+        (randSeed) => (ISymbolicExpressionTreeProblem)new RoyalSymbolProblem(), 
+      };
+
+      var maxSizes = new int[] { 32, 64, 128, 256 };
+      int nReps = 20;
+      int maxIterations = 50000;
+      foreach (var instanceFactory in instanceFactories) {
+        foreach (var conf in GenerateConfigurations(instanceFactory, nReps, maxSizes)) {
+          RunRandomSearchNoResamplingForProblem(conf.RandSeed, conf.Problem, maxIterations, conf.MaxSize);
+        }
+      }
+    }
+    #endregion
+
+    #region findphrases
+    [TestMethod]
+    public void RunPureRandomSearchFindPhrasesProblem() {
+      var instanceFactories = new Func<int, ISymbolicExpressionTreeProblem>[]
+      {
+        (randSeed) => (ISymbolicExpressionTreeProblem) new FindPhrasesProblem(new Random(randSeed), 20, 5, 3, 5, 0, 1, 0, true), 
+        (randSeed) => (ISymbolicExpressionTreeProblem) new FindPhrasesProblem(new Random(randSeed), 20, 5, 3, 5, 0, 1, 0, false), 
+        (randSeed) => (ISymbolicExpressionTreeProblem) new FindPhrasesProblem(new Random(randSeed), 20, 5, 3, 5, 50, 1, 0.8, false), 
+      };
+
+      var maxSizes = new int[] { 15 * 3 }; // * 3 for non-terminals
+      int nReps = 20;
+      int maxIterations = 50000;
+      foreach (var instanceFactory in instanceFactories) {
+        foreach (var conf in GenerateConfigurations(instanceFactory, nReps, maxSizes)) {
+          RunPureRandomSearchForProblem(conf.RandSeed, conf.Problem, maxIterations, conf.MaxSize);
+        }
+      }
+    }
+    [TestMethod]
+    public void RunRandomSearchNoResamplingFindPhrasesProblem() {
+      var instanceFactories = new Func<int, ISymbolicExpressionTreeProblem>[]
+      {
+        (randSeed) => (ISymbolicExpressionTreeProblem) new FindPhrasesProblem(new Random(randSeed), 20, 5, 3, 5, 0, 1, 0, true), 
+        (randSeed) => (ISymbolicExpressionTreeProblem) new FindPhrasesProblem(new Random(randSeed), 20, 5, 3, 5, 0, 1, 0, false), 
+        (randSeed) => (ISymbolicExpressionTreeProblem) new FindPhrasesProblem(new Random(randSeed), 20, 5, 3, 5, 50, 1, 0.8, false), 
+      };
+
+      var maxSizes = new int[] { 15 * 3 }; // * 3 for non-terminals
+      int nReps = 20;
+      int maxIterations = 50000;
+      foreach (var instanceFactory in instanceFactories) {
+        foreach (var conf in GenerateConfigurations(instanceFactory, nReps, maxSizes)) {
+          RunRandomSearchNoResamplingForProblem(conf.RandSeed, conf.Problem, maxIterations, conf.MaxSize);
+        }
+      }
+    }
+
+    #endregion
+
+    #region artificial ant
+    [TestMethod]
+    public void RunPureRandomSearchArtificialAntProblem() {
+      var instanceFactories = new Func<int, ISymbolicExpressionTreeProblem>[]
+      {
+        (randSeed) => (ISymbolicExpressionTreeProblem) new SantaFeAntProblem(), 
+      };
+
+      var maxSizes = new int[] { 30, 50, 100 }; // size of sequential representation is 17
+      int nReps = 20;
+      int maxIterations = 100000; // randomsearch finds the optimum almost always for 100000 evals
+      foreach (var instanceFactory in instanceFactories) {
+        foreach (var conf in GenerateConfigurations(instanceFactory, nReps, maxSizes)) {
+          RunPureRandomSearchForProblem(conf.RandSeed, conf.Problem, maxIterations, conf.MaxSize);
+        }
+      }
+    }
+    [TestMethod]
+    public void RunRandomSearchNoResamplingArtificialAntProblem() {
+      var instanceFactories = new Func<int, ISymbolicExpressionTreeProblem>[]
+      {
+        (randSeed) => (ISymbolicExpressionTreeProblem) new SantaFeAntProblem(), 
+      };
+
+      var maxSizes = new int[] { 30, 50, 100 }; // size of sequential representation is 17
+      int nReps = 20;
+      int maxIterations = 100000; // randomsearch finds the optimum almost always for 100000 evals
+      foreach (var instanceFactory in instanceFactories) {
+        foreach (var conf in GenerateConfigurations(instanceFactory, nReps, maxSizes)) {
+          RunRandomSearchNoResamplingForProblem(conf.RandSeed, conf.Problem, maxIterations, conf.MaxSize);
+        }
+      }
+    }
+    #endregion
+
+    #region symb-reg-poly-10
+    [TestMethod]
+    public void RunPureRandomSearchPoly10Problem() {
+      var instanceFactories = new Func<int, ISymbolicExpressionTreeProblem>[]
+      {
+        (randSeed) => (ISymbolicExpressionTreeProblem) new SymbolicRegressionPoly10Problem(), 
+      };
+
+      var maxSizes = new int[] { 30, 50, 100 }; // size of sequential representation is 23
+      int nReps = 20;
+      int maxIterations = 100000; // sequentialsearch should find the optimum within 100000 evals
+      foreach (var instanceFactory in instanceFactories) {
+        foreach (var conf in GenerateConfigurations(instanceFactory, nReps, maxSizes)) {
+          RunPureRandomSearchForProblem(conf.RandSeed, conf.Problem, maxIterations, conf.MaxSize);
+        }
+      }
+    }
+    [TestMethod]
+    public void RunRandomSearchNoResamplingPoly10Problem() {
+      var instanceFactories = new Func<int, ISymbolicExpressionTreeProblem>[]
+      {
+        (randSeed) => (ISymbolicExpressionTreeProblem) new SymbolicRegressionPoly10Problem(), 
+      };
+
+      var maxSizes = new int[] { 30, 50, 100 }; // size of sequential representation is 23
+      int nReps = 20;
+      int maxIterations = 100000; // sequentialsearch should find the optimum within 100000 evals
+      foreach (var instanceFactory in instanceFactories) {
+        foreach (var conf in GenerateConfigurations(instanceFactory, nReps, maxSizes)) {
+          RunRandomSearchNoResamplingForProblem(conf.RandSeed, conf.Problem, maxIterations, conf.MaxSize);
+        }
+      }
+    }
+    #endregion
+
+    #region helpers
+    private IEnumerable<Configuration> GenerateConfigurations(Func<int, ISymbolicExpressionTreeProblem> problemFactory,
+      int nReps,
+      IEnumerable<int> maxSizes
+      ) {
+      var seedRand = new Random(randSeed);
+      // the problem seed is the same for all configuratons 
+      // this guarantees that we solve the _same_ problem each time
+      // with different solvers and multiple repetitions
+      var problemSeed = randSeed;
+      for (int i = 0; i < nReps; i++) {
+        // in each repetition use the same random seed for all solver configuratons
+        // do nReps with different seeds for each configuration
+        var solverSeed = seedRand.Next();
+        foreach (var maxSize in maxSizes) {
+          yield return new Configuration {
+            MaxSize = maxSize,
+            Problem = problemFactory(problemSeed),
+            RandSeed = solverSeed
+          };
+        }
+      }
+    }
+
+    private static void RunPureRandomSearchForProblem(
+      int randSeed,
+      ISymbolicExpressionTreeProblem problem,
+      int maxIters,
+      int maxSize
+      ) {
+      var solver = new RandomSearch(problem, new Random(randSeed), maxSize);
+      var problemName = problem.GetType().Name;
+      var bestKnownQuality = problem.BestKnownQuality(maxSize);
+      RunSolver(solver, problemName, bestKnownQuality, maxIters, maxSize);
+    }
+
+    private static void RunRandomSearchNoResamplingForProblem(
+  int randSeed,
+  ISymbolicExpressionTreeProblem problem,
+  int maxIters,
+  int maxSize
+  ) {
+      var solver = new SequentialSearch(problem, maxSize, new Random(randSeed), 0,
+        new GenericGrammarPolicy(problem, new RandomPolicy(), false));
+
+      var problemName = problem.GetType().Name;
+      var bestKnownQuality = problem.BestKnownQuality(maxSize);
+      RunSolver(solver, problemName, bestKnownQuality, maxIters, maxSize);
+    }
+
+    private static void RunSolver(ISolver solver, string problemName, double bestKnownQuality, int maxIters, int maxSize) {
+      int iterations = 0;
+      var globalStatistics = new SentenceSetStatistics(bestKnownQuality);
+      var gpName = solver.GetType().Name;
+      solver.SolutionEvaluated += (sentence, quality) => {
+        iterations++;
+        globalStatistics.AddSentence(sentence, quality);
+
+        if (iterations % 1000 == 0) {
+          Console.WriteLine("\"{0,25}\" {1} \"{2,25}\" {3}", gpName, maxSize, problemName, globalStatistics);
+        }
+      };
+
+      solver.Run(maxIters);
+    }
+    #endregion
+  }
+}
Index: branches/HeuristicLab.Problems.GrammaticalOptimization/Test/RunDemo.cs
===================================================================
--- branches/HeuristicLab.Problems.GrammaticalOptimization/Test/RunDemo.cs	(revision 11981)
+++ branches/HeuristicLab.Problems.GrammaticalOptimization/Test/RunDemo.cs	(revision 11981)
@@ -0,0 +1,157 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using System.Threading.Tasks;
+using HeuristicLab.Algorithms.Bandits;
+using HeuristicLab.Algorithms.Bandits.BanditPolicies;
+using HeuristicLab.Algorithms.Bandits.GrammarPolicies;
+using HeuristicLab.Algorithms.GrammaticalOptimization;
+
+namespace HeuristicLab.Problems.GrammaticalOptimization.Test {
+  class RunDemo {
+    private static void RunGridTest() {
+      int maxIterations = 200000; // for poly-10 with 50000 evaluations no successful try with hl yet
+      //var globalRandom = new Random(31415);
+      var localRandSeed = new Random().Next();
+      var reps = 20;
+
+      var policyFactories = new Func<IBanditPolicy>[]
+        {
+         //() => new RandomPolicy(), 
+         // () => new ActiveLearningPolicy(),  
+         //() => new EpsGreedyPolicy(0.01, (aInfo)=> aInfo.MaxReward, "max"), 
+         //() => new EpsGreedyPolicy(0.05, (aInfo)=> aInfo.MaxReward, "max"), 
+         //() => new EpsGreedyPolicy(0.1, (aInfo)=> aInfo.MaxReward, "max"), 
+         //() => new EpsGreedyPolicy(0.2, (aInfo)=> aInfo.MaxReward, "max"), 
+         ////() => new GaussianThompsonSamplingPolicy(), 
+         //() => new GaussianThompsonSamplingPolicy(true), 
+         //() => new GenericThompsonSamplingPolicy(new GaussianModel(0.5, 10, 1)), 
+         //() => new GenericThompsonSamplingPolicy(new GaussianModel(0.5, 10, 1, 1)), 
+         ////() => new BernoulliThompsonSamplingPolicy(),
+         //() => new GenericThompsonSamplingPolicy(new BernoulliModel(1, 1)), 
+         //() => new EpsGreedyPolicy(0.01), 
+         //() => new EpsGreedyPolicy(0.05), 
+         //() => new EpsGreedyPolicy(0.1), 
+         //() => new EpsGreedyPolicy(0.2), 
+         //() => new EpsGreedyPolicy(0.5), 
+         //() => new UCTPolicy(0.01),
+         //() => new UCTPolicy(0.05),
+         //() => new UCTPolicy(0.1),
+         //() => new UCTPolicy(0.5),
+         //() => new UCTPolicy(1),
+         //() => new UCTPolicy(2),
+         //() => new UCTPolicy( 5),
+         //() => new UCTPolicy( 10),
+         //() => new ModifiedUCTPolicy(0.01),
+         //() => new ModifiedUCTPolicy(0.05),
+         //() => new ModifiedUCTPolicy(0.1),
+         //() => new ModifiedUCTPolicy(0.5),
+         //() => new ModifiedUCTPolicy(1),
+         //() => new ModifiedUCTPolicy(2),
+         //() => new ModifiedUCTPolicy( 5),
+         //() => new ModifiedUCTPolicy( 10),
+         //() => new UCB1Policy(), 
+         //() => new UCB1TunedPolicy(), 
+         //() => new UCBNormalPolicy(), 
+         //() => new BoltzmannExplorationPolicy(1),
+         //() => new BoltzmannExplorationPolicy(10),
+         //() => new BoltzmannExplorationPolicy(20),
+         //() => new BoltzmannExplorationPolicy(100),
+         //() => new BoltzmannExplorationPolicy(200),
+         //() => new BoltzmannExplorationPolicy(500),
+         // () => new ChernoffIntervalEstimationPolicy( 0.01), 
+         // () => new ChernoffIntervalEstimationPolicy( 0.05),
+         // () => new ChernoffIntervalEstimationPolicy( 0.1),
+         // () => new ChernoffIntervalEstimationPolicy( 0.2),
+         //() => new ThresholdAscentPolicy(5, 0.01), 
+         //() => new ThresholdAscentPolicy(5, 0.05),
+         //() => new ThresholdAscentPolicy(5, 0.1),
+         //() => new ThresholdAscentPolicy(5, 0.2),
+         //() => new ThresholdAscentPolicy(10, 0.01), 
+         //() => new ThresholdAscentPolicy(10, 0.05),
+         //() => new ThresholdAscentPolicy(10, 0.1),
+         //() => new ThresholdAscentPolicy(10, 0.2),
+         //() => new ThresholdAscentPolicy(50, 0.01), 
+         //() => new ThresholdAscentPolicy(50, 0.05),
+         //() => new ThresholdAscentPolicy(50, 0.1),
+         //() => new ThresholdAscentPolicy(50, 0.2),
+         //() => new ThresholdAscentPolicy(100, 0.01), 
+         () => new ThresholdAscentPolicy(100, 0.05),
+         //() => new ThresholdAscentPolicy(100, 0.1),
+         //() => new ThresholdAscentPolicy(100, 0.2),
+         //() => new ThresholdAscentPolicy(500, 0.01), 
+         //() => new ThresholdAscentPolicy(500, 0.05),
+         //() => new ThresholdAscentPolicy(500, 0.1),
+         //() => new ThresholdAscentPolicy(500, 0.2),
+         //() => new ThresholdAscentPolicy(5000, 0.01), 
+         //() => new ThresholdAscentPolicy(10000, 0.01), 
+        };
+
+      var instanceFactories = new Func<Random, Tuple<IProblem, int>>[]
+      {
+        //(rand) => Tuple.Create((IProblem)new SantaFeAntProblem(), 17),
+        //(rand) => Tuple.Create((IProblem)new FindPhrasesProblem(rand, 10, numPhrases:5, phraseLen:3, numOptimalPhrases:5, numDecoyPhrases:0, correctReward:1, decoyReward:0, phrasesAsSets:false ), 15),
+        //(rand) => Tuple.Create((IProblem)new FindPhrasesProblem(rand, 10, numPhrases:5, phraseLen:3, numOptimalPhrases:5, numDecoyPhrases:0, correctReward:1, decoyReward:0, phrasesAsSets:true ), 15),
+        //(rand) => Tuple.Create((IProblem)new FindPhrasesProblem(rand, 10, numPhrases:5, phraseLen:3, numOptimalPhrases:5, numDecoyPhrases:200, correctReward:1, decoyReward:0.5, phrasesAsSets:false), 15),
+        //(rand) => Tuple.Create((IProblem)new FindPhrasesProblem(rand, 10, numPhrases:5, phraseLen:3, numOptimalPhrases:5, numDecoyPhrases:200, correctReward:1, decoyReward:0.5, phrasesAsSets:true), 15),
+        (rand) => Tuple.Create((IProblem)new SymbolicRegressionPoly10Problem(), 23)
+      };
+
+      foreach (var instanceFactory in instanceFactories) {
+        foreach (var useCanonical in new bool[] { true /*, false */ }) {
+          foreach (var randomTries in new int[] { 1 /*, 1, 10 /*, /* 5, 100 /*, 500, 1000 */}) {
+            foreach (var policyFactory in policyFactories) {
+              var myRandomTries = randomTries;
+              var localRand = new Random(localRandSeed);
+              var options = new ParallelOptions();
+              options.MaxDegreeOfParallelism = 1;
+              Parallel.For(0, reps, options, (i) => {
+                Random myLocalRand;
+                lock (localRand)
+                  myLocalRand = new Random(localRand.Next());
+
+                int iterations = 0;
+                var globalStatistics = new SentenceSetStatistics();
+
+                // var problem = new SymbolicRegressionPoly10Problem();
+                // var problem = new SantaFeAntProblem();
+                //var problem = new PalindromeProblem();
+                //var problem = new HardPalindromeProblem();
+                //var problem = new RoyalPairProblem();
+                //var problem = new EvenParityProblem();
+                // var alg = new MctsSampler(problem.Item1, problem.Item2, myLocalRand, myRandomTries, policy()); 
+                var instance = instanceFactory(myLocalRand);
+                var problem = instance.Item1;
+                var maxLen = instance.Item2;
+                var alg = new SequentialSearch(problem, maxLen, myLocalRand, myRandomTries,
+                  new GenericGrammarPolicy(problem, policyFactory(), useCanonical));
+                // var alg = new SequentialSearch(problem, maxLen, myLocalRand,
+                //   myRandomTries,
+                //   new GenericFunctionApproximationGrammarPolicy(problem,
+                //     useCanonical));
+                //var alg = new ExhaustiveBreadthFirstSearch(problem, 25);
+                //var alg = new AlternativesContextSampler(problem, 25);
+
+                alg.SolutionEvaluated += (sentence, quality) => {
+                  iterations++;
+                  globalStatistics.AddSentence(sentence, quality);
+                  if (iterations % 1000 == 0) {
+                    Console.WriteLine("{0,3} {1,5} \"{2,25}\" {3} {4} {5}", i, myRandomTries, policyFactory(), useCanonical, problem.ToString(), globalStatistics);
+                  }
+                };
+                alg.FoundNewBestSolution += (sentence, quality) => {
+                  //Console.WriteLine("{0,5} {1,25} {2} {3}",
+                  //  myRandomTries, policyFactory(), useCanonical,
+                  //  globalStatistics);
+                };
+
+                alg.Run(maxIterations);
+              });
+            }
+          }
+        }
+      }
+    }
+  }
+}
